@warnings
@autoerror
@version 1.4
@insert SceneMan.inc

generic
{
	noparent = nil;
	newscenename = getfile("Save new scene as...?","*.lws");
	if(newscenename == nil)
		return;
	savescene(newscenename);				// saves current scene
	newscene = SceneMan(newscenename,false);			// and then accesses it immediately through sceneman

	objcount = newscene.objectCount;
	lgtcount = newscene.lightCount;

	if(objcount > 200)						// if objcount exceeds 200, turn on warn 'flag'
		warn = "yes";

	if(!reqbegin("ADOPTION Multi-Object Parenting"))
	{
		error("Panel Services Plug-In not avaiable");
		return;
	}
	reqsize(360,60);
	qmethodall[1] = "All Objects/Lights";						// five arrays containing five methods of adoption
	qmethodall[2] = "All Objects Only";
	qmethodall[3] = "All Lights Only";
	qmethodall[4] = "Selected Only";
	qmethodall[5] = "Objects/Lights of Prefix Only"; 
	qpo = ctlmeshitems("Parent Object");						// retrieve all meshes in popup
	qmethods = ctlpopup("Method",1,qmethodall);				// retrieve method arrays in popup, too
	ctlposition(qmethods,250,0);									// just positioning stuff
	
	if(reqpost())
	{
		parentobj = getvalue(qpo);				// parentobj now contains an object id
		method = getvalue(qmethods);			// method now contains an integer between 1 to 5
	}
	reqend();

	if(parentobj == nil)
	{
		error("No parent object was selected.");
		return;
	}

	parentobjname = parentobj.name;		// retrieves string name of parent object to be used later to compare

	if(method == 1)
	{
		for(i=1;i<=objcount;++i)
		{
			objlist = newscene.objectID[i];
			objlistarray[i] = objlist;
			objlistname = newscene.objectAlias(objlist);	
			if(objlistname == parentobjname)			// if the current object is the parent...
			{
				parentobjID = objlist;					// then capture the parentobjID for reference later
				objlistarray[i] = nil;
			}
		}
		for(i=1;i<=objcount;++i)
		{
			if(objlistarray[i] != nil)
			{
				newscene.setParentObject(objlistarray[i],parentobjID);
			}			
		}
		for(h=1;h<=lgtcount;++h)
		{
			lgtlist = newscene.lightID[h];	
			lgtlistarray[h] = lgtlist;						// lgtlistarray[h] now contains the array of lightIDs
			newscene.setParentObject(lgtlistarray[h],parentobjID);
		}

		reqend();
	}

	if(method == 2)							// if all objects only method was selected
	{
		for(i=1;i<=objcount;++i)
		{
			objlist = newscene.objectID[i];
			objlistarray[i] = objlist;
			objlistname = newscene.objectAlias(objlist);
			if(objlistname == parentobjname)			// if the current object is the parent...
			{
				parentobjID = objlist;					// then capture the parentobjID for reference later
				objlistarray[i] = nil;					// mark that part in the array nil so that the parent won't be parented to itself
			}
		}
		for(i=1;i<=objcount;++i)
		{
			if(objlistarray[i] != nil)
			{
				newscene.setParentObject(objlistarray[i],parentobjID);
			}
		}
	}

	if(method == 3)							// if all lights only method was selected
	{
		for(i=1;i<=objcount;++i)
		{
			objlist = newscene.objectID[i];
			objlistname = newscene.objectAlias(objlist);
			if(objlistname == parentobjname)			// if the current object is the parent...
				parentobjID = objlist;					// then capture the parentobjID for reference later
		}
		for(h=1;h<=lgtcount;++h)
		{
			lgtlist = newscene.lightID[h];
			lgtlistarray[h] = lgtlist;				// lgtlistarray is an array containing all of the id's of lights
			newscene.setParentObject(lgtlistarray[h],parentobjID);
		}
	}

	if(method == 4)							// if selection method was selected
	{
		if(objcount >= 200)
		{
			error("Selection Method only supports 200 objects");
			return;
		}

		reqbegin("ADOPTION Method: Selected Only");
		reqsize(750,700);
		show = "yes";						// default flag to show or not to show object in requester
		e = 0;								// e represents column coordinates
		a = -10;								// a represents row coordinates
		
		for(i=1;i<=objcount;++i)			// as long as i is less or equal than the object count, do this...
		{
			objlist = newscene.objectID[i];		// objlist will now contain first objectID instance
			objlistarray[i] = objlist;				// objlistarray created for later reference, array contains objectIDs
			objlistname = newscene.objectAlias(objlist);			// the current objlist name is retrieved
			if(objlistname == parentobjname)					// if current objlist object is the parent object...
				show = "no";										// tag it as a 'no show'
			if(show == "yes")										// only items with a 'yes show' can be displayed
			{
				c[i] = ctlcheckbox(objlistname,0);			// c[i] now contains an array equal to the object count and will display a requester with a checkbox and a corresponding object name

				b = c[i];											// b now contains the object id of the current object in the c array
				a = a + 16;											// positioning stuff only
				if(i == 40)											// if item instance is numbered 40 then move to next column, etc....
				{
					e = 150;
					a = 6;
				}
				if(i == 80)
				{
					e = 300;
					a = 6;
				}
				if(i == 120)
				{
					e = 450;
					a = 6;
				}
				if(i == 160)
				{
					e = 600;
					a = 6;
				}
				ctlposition(b,e,a);								// position each check box: b = itemID(an array), e = column, a = an increasing row
			}
			else								// if instance is the parent...
			{
				skipped = i;							// skip this instance (i) when running getvalue()
				parentobjID = objlist;				// get the sceneman objectID of parent
				show = "yes";						// revert to default value of 'yes show' for other instances
			}
		}
		reqpost();


		for(i=1;i<=objcount;++i)		// must process again to retrieve boolean values on whether or not specific objects were chosen
		{
			if(i != skipped)
			{
				chosenchildren[i] = getvalue(c[i]);		// chosenchildren is yet another array equal to the object count and contains the boolean values gotten from c[i] previously
				// since boolean values will be sequentially retrieved, the setparentobject command must be
				// included in the control struct FOR. if boolean is 1, then set that object as a child of the
				// parent object.

				if(chosenchildren[i] == 1)
				{
					newscene.setParentObject(objlistarray[i],parentobjID);
				}
			}
		}
		newscene.save();

		reqend();
	}
	if(method == 5)				// method of prefix
	{	
		reqbegin("ADOPTION Method: Objects/Lights of Prefix Only");
	
		instancetype[1] = "Object";
		instancetype[2] = "Light";
		t = ctlchoice("Choose Instance Type",1,instancetype);
		p = ctlstring("Enter Prefix","");
		
		reqpost();

		type = getvalue(t);
		prefix = getvalue(p);
		prefixlength = size(prefix);

		reqend();
		if(type == 1)				// if instancetype was objects...
		{
			try = 0;					// just an indicator, that's all
			for(i=1;i<=objcount;++i)
			{
				objlist = newscene.objectID[i];		// objlist contains current objectID
				objlistname = newscene.objectAlias(objlist);	// gets objectalias of current file
				if(objlistname == parentobjname)			// if the current object is the parent...
						parentobjID = objlist;					// then capture the parentobjID for reference later
				currentprefix = strleft(objlistname,prefixlength);
				if(currentprefix == prefix)			// if the scanned prefix matches the prefix entered...
				{
					if(objlist == parentobjID)			// if the object in question is the parent...
					{
						objlistarray[i] = nil;				// then there is no ID assignment.
					}
					objlistarray[i] = objlist;			// creates objlistarray to contain the IDs that have similar prefixes
					++try;
				}
				else
					objlistarray[i] = nil;					// fills array in between
			}
			if(try == 0)
			{
				error("No similar prefixes found.");
				return;
			}
			for(i=1;i<=objcount;++i)
			{
				if(objlistarray[i] != nil)
				{
					newscene.setParentObject(objlistarray[i],parentobjID);
				}
			}
		}

		if(type == 2)				// if instancetype was light....
		{
			try = 0;					
			for(g=1;g<=objcount;++g)
			{
				objlist = newscene.objectID[g];		// objlist contains current objectID
				objlistname = newscene.objectAlias(objlist);	// gets objectalias of current file
				if(objlistname == parentobjname)			// if the current object is the parent...
						parentobjID = objlist;					// then capture the parentobjID for reference later
			}

			for(i=1;i<=lgtcount;++i)
			{
				lgtlist = newscene.lightID[i];		
				lgtlistname = newscene.lightName(lgtlist);
				if(lgtlistname == nil)
					lgtlistname = "Light";
				currentprefix = strleft(lgtlistname,prefixlength);
				if(currentprefix == prefix)			// if the scanned prefix matches the prefix entered...
				{
					lgtlistarray[i] = lgtlist;			
					++try;
				}
				else
					lgtlistarray[i] = nil;					// fills array in between
			}
			if(try == 0)
			{
				error("No similar prefixes found.");
				return;
			}
			for(i=1;i<=lgtcount;++i)
			{
				if(lgtlistarray[i] != nil)
				{
					newscene.setParentObject(lgtlistarray[i],parentobjID);
				}
			}
		}
	}

	newscene.save();

}

